import { IRuleMetadata, RuleFailure } from 'tslint';
import { AbstractRule } from 'tslint/lib/rules';
import { Decorator, SourceFile } from 'typescript';
import { NgWalker } from './angular/ngWalker';
import { DecoratorKeys, MetadataTypes } from './util/utils';
interface FailureParameters {
    readonly className: string;
    readonly decoratorName: DecoratorKeys;
    readonly metadataType: MetadataTypes;
}
export declare const getFailureMessage: (failureParameters: FailureParameters) => string;
export declare class Rule extends AbstractRule {
    static readonly metadata: IRuleMetadata;
    static readonly FAILURE_STRING = "The decorator \"%s\" is not allowed for class \"%s\" because it is decorated with \"%s\"";
    apply(sourceFile: SourceFile): RuleFailure[];
}
export declare class ContextualDecoratorWalker extends NgWalker {
    protected visitMethodDecorator(decorator: Decorator): void;
    protected visitPropertyDecorator(decorator: Decorator): void;
    private validateDecorator;
}
export {};
