import * as Lint from 'tslint';
import * as ts from 'typescript';
import { NgWalker } from './angular/ngWalker';
import { DirectiveMetadata } from './angular/metadata';
export declare class Rule extends Lint.Rules.AbstractRule {
    static readonly metadata: Lint.IRuleMetadata;
    static readonly FAILURE_STRING = "The name of the class %s should end with the suffix %s (https://angular.io/styleguide#style-02-03)";
    static validate(className: string, suffixes: string[]): boolean;
    apply(sourceFile: ts.SourceFile): Lint.RuleFailure[];
}
export declare class ClassMetadataWalker extends NgWalker {
    protected visitNgDirective(metadata: DirectiveMetadata): void;
}
