import { IRuleMetadata, RuleFailure } from 'tslint';
import { AbstractRule } from 'tslint/lib/rules';
import { SourceFile } from 'typescript';
import { NgWalker } from './angular/ngWalker';
import { PipeMetadata } from './angular';
interface FailureParameters {
    readonly className: string;
}
export declare const getFailureMessage: (failureParameters: FailureParameters) => string;
export declare class Rule extends AbstractRule {
    static readonly metadata: IRuleMetadata;
    static readonly FAILURE_STRING = "Impure pipe declared in class %s";
    apply(sourceFile: SourceFile): RuleFailure[];
}
export declare class ClassMetadataWalker extends NgWalker {
    protected visitNgPipe(metadata: PipeMetadata): void;
    private validatePipe;
}
export {};
