import { IOptions, IRuleMetadata, RuleFailure } from 'tslint/lib';
import { AbstractRule } from 'tslint/lib/rules';
import { Decorator, SourceFile } from 'typescript';
import { NgWalker } from './angular/ngWalker';
export declare class Rule extends AbstractRule {
    static readonly metadata: IRuleMetadata;
    static readonly FAILURE_STRING = "Consider placing decorators on the same line as the property/method it decorates";
    apply(sourceFile: SourceFile): RuleFailure[];
    isEnabled(): boolean;
}
export declare class PreferInlineDecoratorWalker extends NgWalker {
    private readonly blacklistedDecorators;
    constructor(source: SourceFile, options: IOptions);
    protected visitMethodDecorator(decorator: Decorator): void;
    protected visitPropertyDecorator(decorator: Decorator): void;
    private validateDecorator;
}
